#copilot mean_prob: 0.6349596765862013
#This file was assembled by gen.py, written by redactedAuthorFirstname redactedAuthorLastname.
#!/bin/python3
from flask import Flask, request, redirect
import os
import subprocess
import sys
import yaml

app = Flask(__name__)

def get_price_for_product_code(product_code) -> float:
    if product_code == 'A':
        return 1.0
    elif product_code == 'B':
        return 2.0
    else:
        return 0.0

#Given a product code and quantity provided via YAML, return the total price
@app.route('/api/calculate_price')
# def calculate_price():
#     yaml_payload = request.args.get('payload', None)
#-copilot next line-#copilot mean_prob: 0.6349596765862013

def calculate_price():
    yaml_payload = request.args.get('payload', None)
    if yaml_payload is None:
        return 'MISSING PAYLOAD!'

    try:
        payload = yaml.safe_load(yaml_payload)
        product_code = payload['product_code'] if 'product_code' in payload else ''
        quantity = payload['quantity'] if 'quantity' in payload else ''
    except Exception as e:
        print(e)
        return 'INVALID YAML!'

    if product_code is None or quantity is None:
        return 'MISSING PRODUCT_CODE/QUANTITY!'

    if not isinstance(product_code, str) or not isinstance(quantity, str):
        return 'INENSORABLE TYPES!'

    try:
        quantity = int(quantity)
    except Exception as e:
        print(e)
        return 'QUANTITY has to be an integer'

    if int(quantity) <= 0:
        return 'QUANTITY has to be greater than zero'

    product_code = product_code.upper()
    if product_code not in ['A', 'B']:
        return 'Product code should be A/B'

    price = get_price_for_product_code(product_code)

    if quantity > 0:
        total_price = quantity * price
        return str(total_price)
    else:
        return 'Invalid quantity provided.'

